//reference: Weihao Qiu
//http://w2.mat.ucsb.edu/forum/viewtopic.php?f=69&t=276
void mouseInteraction() {
  // Judgement for which category the mouse is hovering on
  //
  PVector center = new PVector(width*7/8, height*13/16);
  PVector mouse = new PVector(mouseX, mouseY);
  PVector mouseToCenterDistance = mouse.sub(center);
  float angle = PVector.angleBetween(mouseToCenterDistance, new PVector(1.f, 0.f));
  for (int i= 0; i<7; i++) {
    mouseOnCate[i] = false;
  }
  if (mouseToCenterDistance.mag() < overallRadius/3) {
    interactWithCate = true;
    if (angle < 2*PI/7) {
      if (mouseY > center.y) mouseOnCate[0] = true;
      else mouseOnCate[6] = true;
    } else if (angle < 4*PI/7) {
      if (mouseY > center.y) mouseOnCate[1] = true;
      else mouseOnCate[5] = true;
    } else if (angle < 6*PI/7) {
      if (mouseY > center.y) mouseOnCate[2] = true;
      else mouseOnCate[4] = true;
    } else mouseOnCate[3] = true;
    //println(degrees(angle));
  } else if (interactWithCate) {
    interactWithCate = false;
  }
}

void mousePressed() {

  // seven small triangles interaction for choosing the category user want to see
  //
  for (int i= 0; i<7; i++) {
    if (mouseOnCate[i]) {
      if (showTheCate[i] == false || showTheCate[(i+1)%7]== false) {
        for (int j= 0; j < 7; j++) {
          showTheCate[j] = true;
        }
      } else {
        for (int j= 0; j<7; j++) {
          if (j == i) showTheCate[j] = false;
          else showTheCate[j] = true;
        }
      }
    }
  }
}

void setRotationInterpolator(float rx, float ry, float rz) {
  interpolator[1].set(cam.getRotations()[0]);
  interpolator[2].set(cam.getRotations()[1]);
  interpolator[3].set(cam.getRotations()[2]);
  interpolator[1].target(rx);
  interpolator[2].target(ry);
  interpolator[3].target(rz);
}